package lab4;

import java.io.PrintStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import c4e.phidget.HardwareInterface;
import c4e.util.ToolBox;

public class Server extends HardwareInterface
{
	// ------------------------------------Attribute Section
	private long timerDelay;

	// ------------------------------------Constructor Section
	public Server(boolean debug)
	{
		super(debug);
		this.timerDelay = 5000;
		this.setTimer(this.timerDelay);
	}

	// ------------------------------------Behaviour Section
	@Override
	public void timerCallback()
	{
		String regex = "FLAG sender=([a-zA-Z]+)&waves=([1-3])";
		Pattern pattern = Pattern.compile(regex);
		this.setServoEngageState(0, true);
		
		try
		{
			ServerSocket server = new ServerSocket(55000);
			
			while (true)
			{
				System.out.println("Waiting for a connection ... ");
				Socket client = server.accept();
				
				// display the client's IP and incoming request
				
				PrintStream out = new PrintStream(client.getOutputStream(), true);
				Scanner in = new Scanner(client.getInputStream());
				String request = in.nextLine();
				String sender;
				int waves;
				
				// determine if the request is valid
				// if not valid
				// 			display an error message and also send this message to the client
				// else 
				// 			extract the sender's name and number of waves
				// 			move the flag, say between 50 degrees and 150 degrees:
				//			for (int i = 0; i < waves; i++)
				//			{
				//				this.setServoPosition(0, 40);
				//				ToolBox.sleep(500);
				//				this.setServoPosition(0, 140);
				//				ToolBox.sleep(500);
				//			}
				
				out.close();
				in.close();
			}
			
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		this.stopMonitoring();
	}
}
